/* LpApplication.h
 * Copyright (c)1999 by Eric Hackborn.
 * All rights reserved.
 *
 * This code is not public domain, nor freely distributable.
 * Please direct any questions or requests to Eric Hackborn,
 * at <hackborn@angryredplanet.com>.
 *
 * ----------------------------------------------------------------------
 *
 * To Do
 * ~~~~~~~~~~
 *
 *	- Nothing!
 *
 * ----------------------------------------------------------------------
 *
 * Known Bugs
 * ~~~~~~~~~~
 *
 *	- None!  Ha ha!
 *
 * ----------------------------------------------------------------------
 *
 * History
 * ~~~~~~~
 * 04.18.99		hackborn
 * Created this file.
 */
 
#ifndef LP_LPAPPLICATION_H
#define LP_LPAPPLICATION_H

#include <be/app/Application.h>
#include <be/storage/File.h>
#include "LpXmlStreamI.h"

/***************************************************************************
 * LP-APPLICATION
 ***************************************************************************/
class LpApplication : public BApplication
{
public:
	LpApplication();
	virtual ~LpApplication();

	virtual void MessageReceived(BMessage*);
	virtual bool QuitRequested(void);
	virtual void AboutRequested(void);
	virtual bool IsQuitting() const;
	
	void ShowEntryWin(void);

private:
	typedef BApplication	inherited;
	BMessenger 				mAboutWin;
	BMessenger 				mEntryWin;
	bool					mIsQuitting;
		
	/* Answer a file with the requested properties.  If the open_mode
	 * includes B_CREATE_FILE, then the new file's MIME string will
	 * be set to the mimeType arg.
	 */
	BFile* SettingsFile(uint32 open_mode,
						const char *fileName,
						const char *mimeType = "text/plain");
	bool VerifySettingsDirectory();

	/* Give all windows the opportunity to write themselves out
	 * to a state file.
	 */
	status_t SaveState();
	/* Read all the entries in the state file, and act accordingly.
	 */
	void ReadState();
	void ReadWindowState(	LpXmlStreamI& stream,
							string_vec& keys,
							string_vec& values);
};

#endif
