/* LpEntryItem.h
 * Copyright (c)2000 by Eric Hackborn.
 * All rights reserved.
 *
 * This code is not public domain, nor freely distributable.
 * Please direct any questions or requests to Eric Hackborn,
 * at <hackborn@angryredplanet.com>.
 *
 * ----------------------------------------------------------------------
 *
 * Known Bugs
 * ~~~~~~~~~~
 *
 *	- None!  Ha ha!
 *
 * ----------------------------------------------------------------------
 *
 * History
 * ~~~~~~~
 * 04.21.00		hackborn
 * Created this file.
 */

#ifndef LP_LPENTRYITEM_H
#define LP_LPENTRYITEM_H

#include <be/interface/ListItem.h>
#include "LpEntryCollection.h"

/*************************************************************************
 * LP-ENTRY-ITEM
 *************************************************************************/
class LpEntryItem : public BStringItem
{
public:
	LpEntryItem(const LpEntry* entry);

	/* Sync my visual appearance with the entry.
	 */
	void Synchronize(const LpEntry* entry);
	/* Remove the entry this item is based upon from the supplied
	 * entry collection.  Answer B_OK if the item was removed,
	 * B_ERROR otherwise.
	 */
	status_t RemoveFrom(LpEntryCollection* collection);

private:
	typedef BStringItem		inherited;
};

#endif
