/* LpWindowStateI.h
 * Copyright (c)2000 by Eric Hackborn.
 * All rights reserved.
 *
 * This code is not public domain, nor freely distributable.
 * Please direct any questions or requests to Eric Hackborn,
 * at <hackborn@angryredplanet.com>.
 *
 * ----------------------------------------------------------------------
 *
 * To Do
 * ~~~~~~~~~~
 *
 *	* Nothing!
 *
 * ----------------------------------------------------------------------
 *
 * Known Bugs
 * ~~~~~~~~~~
 *
 *	* None!  Ha ha!
 *
 * ----------------------------------------------------------------------
 *
 * History
 * ~~~~~~~
 * 04.21.00		hackborn
 * Created this file.
 */

#ifndef LP_LPWINDOWSTATEI_H
#define LP_LPWINDOWSTATEI_H

#include "LpXmlStreamI.h"

#define ARPSTR_WINDOW_XML_TAG	"Window"
#define ARPSTR_TYPE				"type"

/*****************************************************************************
 * LP-WINDOW-STATE-I
 * This class defines an interface that any LesserPasswords windows can
 * implement to hook into certain system features, like persisting the window
 * state between sessions.
 *****************************************************************************/
class LpWindowStateI
{
public:
	virtual ~LpWindowStateI() { }

	/* Implementors should write their state information out to the XML stream,
	 * in the format specified by the file manual/StateXML.
	 */
	virtual ssize_t WriteState(	LpXmlStreamI& stream) = 0;
	virtual ssize_t ReadState(	LpXmlStreamI& stream,
								const char* windowTag,
								const char* windowType) = 0;
};

#endif
