/* string_vec.h
 * Copyright (c)2000 by Eric Hackborn.
 * All rights reserved.
 *
 * Simple utilities for defining and operating on vectors
 * of strings.
 *
 * This code is not public domain, nor freely distributable.
 * Please direct any questions or requests to Eric Hackborn,
 * at <hackborn@angryredplanet.com>.
 *
 * ----------------------------------------------------------------------
 *
 * To Do
 * ~~~~~~~~~~
 *
 *	- Nothing!
 *
 * ----------------------------------------------------------------------
 *
 * Known Bugs
 * ~~~~~~~~~~
 *
 *	- None!  Ha ha!
 *
 * ----------------------------------------------------------------------
 *
 * History
 * ~~~~~~~
 * 04.18.00		hackborn
 * Created this file.
 */

#ifndef LP_STRINGVEC_H
#define LP_STRINGVEC_H


#include <vector.h>
#include <be/support/SupportDefs.h>

typedef vector<char*>		string_vec;
typedef vector<const char*>	cstring_vec;

/* Free every string and erase each entry in the vector.
 */
void FreeVector(string_vec& vec);
/* Answer the index at which the supplied string is
 * found.  Answer -1 if the string is not in the
 * vector.  Index is based on a string comparison, not
 * pointer identity.
 */
int32 IndexFor(const char *str, string_vec& vec);


#endif